unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ColorDialog1: TColorDialog;
    Grid1: TStringGrid;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  s,s2:String;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.Button2Click(Sender: TObject);
var k1,k2,i,j:longint;
 b:word;
 b1,b2:extended;
 code:integer;
begin
K1 := 0;
k2:=0;
 with Grid1 do begin
  for I := 2 to ColCount - 1 do
  for J:= 1 to RowCount - 1 do begin
   val(cells[i,j],b,code);
   if code<>0 then begin
     str(j+1,s);
     ShowMessage ('Error in line '+s);
     Close;
   end;
   if b>2 then begin
    Inc(k1);
    if b>3 then Inc(k2);
   end;
  end;
  b1:=(k1*100)/((Grid1.RowCount-1)*3);
  b2:=(k2*100)/((Grid1.RowCount-1)*3);
  str (b1:5:2,s);
  str (b2:5:2,s2);
  Label1.Caption:='Y='+s+' Y='+s2;
 end;
end;

function DeleteLimiters (var s:string):string;
var p:integer;
begin
 repeat
  p:=pos('  ',s);
  if p>0 then delete (s,p,1);
 until p=0;
 if s[1]=' ' then delete (s,1,1);
 p:=length(s);
 if s[p]=' ' then delete (s,p,1);
 DeleteLimiters:=s;
end;

procedure Error (n:integer);
begin
 str (n,s2);
 ShowMessage ('Error in line '+s2+' of data.txt');
 Form1.Close;
end;

procedure TForm1.Button3Click(Sender: TObject);
var f:TextFile;
 r,i,p,code:longint;
 b:word;
begin
  {$I-}
  AssignFile (f,'base.txt');
  Reset (f);
  {$I+}
  if IoResult <> 0 then begin
   ShowMessage ('Can''t open data.txt in current directory!');
   Form1.Close;
  end;
  r:=1;
  while not eof (f) do begin
   readln (f,s);
   s:=DeleteLimiters(s);
   p:=pos(' ',s);
   if p=0 then Error (r);
   str(r,s2);
   Grid1.Cells[0,r]:=s2;
   Grid1.Cells[1,r]:=copy(s,1,p-1);
   delete (s,1,p);
   for i:=1 to 2 do begin
    p:=pos(' ',s);
    if p=0 then Error (r);
    val(copy(s,1,p-1),b,code);
    if code<>0 then Error (r);
    delete (s,1,p);
    str(b:1,s2);
    Grid1.Cells[i+1,r]:=s2;
   end;
   val(s,b,code);
   if code<>0 then Error (r);
   str(b:1,s2);
   Grid1.Cells[4,r]:=s2;
   Inc(r);
   Grid1.RowCount:=r;
  end;
  Button2.Enabled:=True;
end;


procedure TForm1.FormActivate(Sender: TObject);
begin
 with Grid1 do begin
  Cells[1,0]:='Name';
  Cells[2,0]:='Math';
  Cells[3,0]:='Phys';
  Cells[4,0]:='Inf';
 end;
end;
 
end.
