unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    SaveDialog1: TSaveDialog;
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  NotSaved: boolean;
  defaultName: String;

implementation

{$R *.DFM}

procedure TForm1.Button3Click(Sender: TObject); { }
begin
 if NotSaved then begin
  if MessageDlg ('    !  ?', mtConfirmation, [mbYes,mbNo], 0)=mrYes then begin
   if Form1.SaveDialog1.Execute then begin
    if (FileExists (Form1.SaveDialog1.FileName)) and
       (MessageDlg (' '+ Form1.SaveDialog1.FileName + ' !  ?', mtConfirmation, [mbYes,mbNo], 0)=mrYes) then begin
     Form1.Memo1.Lines.SaveToFile(Form1.SaveDialog1.FileName);
    end;
   end;
  end;
 end;
 NotSaved:=False;
 Memo1.Clear;
 defaultName:='';
end;

procedure TForm1.Button1Click(Sender: TObject); { }
begin
 if OpenDialog1.Execute then begin
  Memo1.Lines.Clear;
  defaultName:=OpenDialog1.FileName;
  Form1.Memo1.Lines.LoadFromFile(defaultName);
 end;
end;

procedure TForm1.Memo1Change(Sender: TObject); {  }
begin
 NotSaved:=True;
end;

procedure TForm1.Button2Click(Sender: TObject); { }
begin
 if defaultName='' then begin
  if Savedialog1.Execute then begin
   defaultName:=SaveDialog1.FileName;
  end
  else Exit;
 end;
 Memo1.Lines.SaveToFile(defaultName);
 NotSaved:=False;
end;

end.
