unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ColorDialog1: TColorDialog;
    procedure FormActivate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  pX,pY:integer;
  Len:Extended;
  s:String;

implementation

{$R *.dfm}

procedure TForm1.FormActivate(Sender: TObject);
begin
 pX:=0;
 pY:=0;
 Len:=0;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 Canvas.MoveTo (pX,pY);
 Canvas.LineTo (X,Y);
 Len:=Len+sqrt(sqr(Px-X)+sqr(pY-Y));
 pX:=X;
 pY:=Y;
 Str(Len:10:2,s);
 Label1.Caption:=s;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 Refresh;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 if ColorDialog1.Execute then Canvas.Pen.Color := ColorDialog1.Color;
end;

end.
