unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ShellCtrls, StdCtrls, ToolWin, Buttons, ExtCtrls,
  Menus, ShellAPI, FileCtrl, AnimationEffect;

type
  TForm1 = class(TForm)
    ShellTreeView1: TShellTreeView;
    ShellListView1: TShellListView;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    PopupMenu1: TPopupMenu;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    Splitter1: TSplitter;
    ToolBar1: TToolBar;
    N5: TMenuItem;
    Splitter2: TSplitter;
    SpeedButton2: TSpeedButton;
    SpeedButton1: TSpeedButton;
    PopupMenu2: TPopupMenu;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    PopupMenu3: TPopupMenu;
    N10: TMenuItem;
    N11: TMenuItem;
    Label1: TLabel;
    ShellComboBox1: TShellComboBox;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    About1: TMenuItem;
    AnimationEffect1: TAnimationEffect;
    procedure N4Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ShellListView1EndDrag(Sender, Target: TObject; X,
      Y: Integer);
    procedure ShellListView1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ShellTreeView1DragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure ShellTreeView1DragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure N6Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure ShellListView1DragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure N5Click(Sender: TObject);
    procedure N15Click(Sender: TObject);
    procedure About1Click(Sender: TObject);

  private
    procedure ConfirmChange(const ACaption, FromFile, ToFile: string);
    { Private declarations }
  public

    { Public declarations }
  end;

var
  Form1: TForm1;
  Atttr,XX,YY: Integer;
  f:file;
  Fpath, DragPath, Kovo:string;

implementation

uses Unit2, FmxUtils, Unit3;


{$R *.dfm}


procedure TForm1.ConfirmChange(const ACaption, FromFile, ToFile: string);
begin
{  if MessageDlg(Format('%s %s to %s?', [ACaption, FromFile, ToFile]),
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin}
    if ACaption = '' then
      MoveFile(FromFile, ToFile)
    else if ACaption = '' then
      CopyFile(FromFile, ToFile)
    else if ACaption = '' then
      RenameFile(FromFile, ToFile);
    ShellTreeView1.Update;
{  end;}
end;


procedure TForm1.N4Click(Sender: TObject);
 begin
  Form1.Enabled:=FALSE;
  Form2.Show;
 end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  ShellListView1.Back
end;

procedure TForm1.FormShow(Sender: TObject);
 begin
   Splitter1.Visible:=Splitter1.Visible xor true;
   ShellTreeView1.Visible:=ShellTreeView1.Visible xor true;
 end;

procedure TForm1.ShellListView1EndDrag(Sender, Target: TObject; X,
  Y: Integer);
 begin
  if Target <> nil then ShellListView1.Update;
 end;

procedure TForm1.ShellListView1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
  with Sender as TShellListView do
  begin
   ShellListView1.GetItemAt(X,Y);
   if X >= 0 then BeginDrag(False);
  end;
end;

procedure TForm1.ShellTreeView1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
 begin
  if Source is TShellListView then
  with ShellTreeView1 do
   begin
    ShellTreeView1.Selected:= ShellTreeView1.GetNodeAt(X, Y);
    DragPath:= Shelltreeview1.SelectedFolder.PathName;
    XX:=Mouse.CursorPos.X;
    YY:=Mouse.CursorPos.Y;
    PopupMenu3.Popup(XX,YY);
   end;
 end;

procedure TForm1.ShellTreeView1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := (Source is TShellListView); {and (DirectoryOutline.GetItem(X, Y) > 0)};
end;

procedure TForm1.N6Click(Sender: TObject);
 begin
  ShellListView1.ViewStyle:=vsIcon;
  N6.Checked:=TRUE;
  N6.RadioItem:=TRUE;
 end;

procedure TForm1.N7Click(Sender: TObject);
 begin
  ShellListView1.ViewStyle:=vsSmallIcon;
  N7.Checked:=TRUE;
  N7.RadioItem:=TRUE;
 end;

procedure TForm1.N8Click(Sender: TObject);
 begin
  ShellListView1.ViewStyle:=vsList;
  N8.Checked:=TRUE;
  N8.RadioItem:=TRUE;
 end;

procedure TForm1.N9Click(Sender: TObject);
 begin
  ShellListView1.ViewStyle:=vsReport;
  N9.Checked:=TRUE;
  N9.RadioItem:=TRUE;
 end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
 begin
  XX:=Mouse.CursorPos.X;
  YY:=Mouse.CursorPos.Y;
  PopupMenu2.Popup(XX,YY);
 end;

procedure TForm1.FormCreate(Sender: TObject);
 begin
{  Width:=Screen.Width DIV 2;
  Height:=Screen.Height DIV 2;}
 end;

procedure TForm1.N10Click(Sender: TObject);
 begin
  ConfirmChange('',Kovo,DragPath);
 end;

procedure TForm1.N11Click(Sender: TObject);
 begin
  ConfirmChange('',Kovo,DragPath);
 end;

procedure TForm1.N2Click(Sender: TObject);
 var
  Atttr: Integer;
  FileName : String;
 begin
   FileName:=ShellListView1.selectedfolder.PathName;
   Atttr:=FileGetAttr(FileName);
   IF Atttr AND faReadOnly<>0 THEN
    BEGIN
     Atttr:=0;
     FileSetAttr(FileName,Atttr);
    END;

   AssignFile(F, FileName);
   Erase(F);

 end;

procedure TForm1.ShellListView1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Kovo:=ShellListView1.selectedfolder.PathName;
end;

procedure TForm1.N5Click(Sender: TObject);
 begin
  Form3.Show;
  Form1.Enabled:=FALSE;
 end;

procedure TForm1.N15Click(Sender: TObject);
 begin
  Application.Terminate;
 end;

procedure TForm1.About1Click(Sender: TObject);
 begin
  ShellAbout(Handle, '', '', 0);
 end;

end.
