unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 with StringGrid1 do begin
  RowCount:=2;
  ColCount:=5;
  ColWidths[0]:=200;  Cells[0,0]:='';
  ColWidths[1]:=100;  Cells[1,0]:='';
  ColWidths[2]:=100;  Cells[2,0]:='';
  ColWidths[3]:=100;  Cells[3,0]:='c';
  ColWidths[4]:=100;  Cells[4,0]:=' ';
 end;
end;

procedure TForm1.Button1Click(Sender: TObject); {}
var i:integer;
begin
 StringGrid1.RowCount:=StringGrid1.RowCount+1;
 for i:=StringGrid1.RowCount downto StringGrid1.Row do
  StringGrid1.Rows[i]:=StringGrid1.Rows[i-1];
 for i:=0 to StringGrid1.ColCount do
 StringGrid1.Cells[i,StringGrid1.Row]:='';
end;

procedure TForm1.Button2Click(Sender: TObject); {}
var i:integer;
begin
 if StringGrid1.RowCount>2 then begin
  for i:=StringGrid1.Row to StringGrid1.RowCount do
   StringGrid1.Rows[i]:=StringGrid1.Rows[i+1];
  StringGrid1.RowCount:=StringGrid1.RowCount-1;
 end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var i,j:integer; b:real; s:String;
begin
 for i:=1 to StringGrid1.RowCount-1 do begin
  b:=0;
  for j:=1 to StringGrid1.ColCount-2 do
   try
    b:=b+StrToInt(StringGrid1.Cells[j,i]);
   except
    on EConvertError do begin
     ShowMessage ('"'+StringGrid1.Cells[j,i]+'" -  ');
     Exit;
    end;
   end;
  Str ((b/(StringGrid1.ColCount-2)):4:2,s);
  StringGrid1.Cells[StringGrid1.ColCount-1,i]:=s;
 end;
end;

end.
